<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Find ServiceType
 * @subpackage Services
 */
class Find extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named
     * findProspectByPhoneNumberOrEmailAddress
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $phoneNumber
     * @param string $emailAddress
     * @return \StructType\Prospect|bool
     */
    public function findProspectByPhoneNumberOrEmailAddress($phoneNumber, $emailAddress)
    {
        try {
            $this->setResult($this->getSoapClient()->findProspectByPhoneNumberOrEmailAddress($phoneNumber, $emailAddress));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Prospect
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
