<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LeaseSearchCriteria StructType
 * @subpackage Structs
 */
class LeaseSearchCriteria extends AuditableDTOSearchCriteria
{
    /**
     * The buildingId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $buildingId;
    /**
     * The tenantId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $tenantId;
    /**
     * Constructor method for LeaseSearchCriteria
     * @uses LeaseSearchCriteria::setBuildingId()
     * @uses LeaseSearchCriteria::setTenantId()
     * @param int $buildingId
     * @param int $tenantId
     */
    public function __construct($buildingId = null, $tenantId = null)
    {
        $this
            ->setBuildingId($buildingId)
            ->setTenantId($tenantId);
    }
    /**
     * Get buildingId value
     * @return int|null
     */
    public function getBuildingId()
    {
        return $this->buildingId;
    }
    /**
     * Set buildingId value
     * @param int $buildingId
     * @return \StructType\LeaseSearchCriteria
     */
    public function setBuildingId($buildingId = null)
    {
        // validation for constraint: int
        if (!is_null($buildingId) && !(is_int($buildingId) || ctype_digit($buildingId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($buildingId, true), gettype($buildingId)), __LINE__);
        }
        $this->buildingId = $buildingId;
        return $this;
    }
    /**
     * Get tenantId value
     * @return int|null
     */
    public function getTenantId()
    {
        return $this->tenantId;
    }
    /**
     * Set tenantId value
     * @param int $tenantId
     * @return \StructType\LeaseSearchCriteria
     */
    public function setTenantId($tenantId = null)
    {
        // validation for constraint: int
        if (!is_null($tenantId) && !(is_int($tenantId) || ctype_digit($tenantId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tenantId, true), gettype($tenantId)), __LINE__);
        }
        $this->tenantId = $tenantId;
        return $this;
    }
}
