<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportConfiguration StructType
 * @subpackage Structs
 */
class ReportConfiguration extends AbstractStructBase
{
    /**
     * The format
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $format;
    /**
     * The reportName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $reportName;
    /**
     * The reportSettings
     * Meta information extracted from the WSDL
     * - arrayType: tns1:ReportSetting[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\ReportSetting[]
     */
    public $reportSettings;
    /**
     * Constructor method for ReportConfiguration
     * @uses ReportConfiguration::setFormat()
     * @uses ReportConfiguration::setReportName()
     * @uses ReportConfiguration::setReportSettings()
     * @param string $format
     * @param string $reportName
     * @param \StructType\ReportSetting[] $reportSettings
     */
    public function __construct($format = null, $reportName = null, array $reportSettings = array())
    {
        $this
            ->setFormat($format)
            ->setReportName($reportName)
            ->setReportSettings($reportSettings);
    }
    /**
     * Get format value
     * @return string|null
     */
    public function getFormat()
    {
        return $this->format;
    }
    /**
     * Set format value
     * @param string $format
     * @return \StructType\ReportConfiguration
     */
    public function setFormat($format = null)
    {
        // validation for constraint: string
        if (!is_null($format) && !is_string($format)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($format, true), gettype($format)), __LINE__);
        }
        $this->format = $format;
        return $this;
    }
    /**
     * Get reportName value
     * @return string|null
     */
    public function getReportName()
    {
        return $this->reportName;
    }
    /**
     * Set reportName value
     * @param string $reportName
     * @return \StructType\ReportConfiguration
     */
    public function setReportName($reportName = null)
    {
        // validation for constraint: string
        if (!is_null($reportName) && !is_string($reportName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reportName, true), gettype($reportName)), __LINE__);
        }
        $this->reportName = $reportName;
        return $this;
    }
    /**
     * Get reportSettings value
     * @return \StructType\ReportSetting[]|null
     */
    public function getReportSettings()
    {
        return $this->reportSettings;
    }
    /**
     * This method is responsible for validating the values passed to the setReportSettings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReportSettings method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReportSettingsForArrayConstraintsFromSetReportSettings(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $reportConfigurationReportSettingsItem) {
            // validation for constraint: itemType
            if (!$reportConfigurationReportSettingsItem instanceof \StructType\ReportSetting) {
                $invalidValues[] = is_object($reportConfigurationReportSettingsItem) ? get_class($reportConfigurationReportSettingsItem) : sprintf('%s(%s)', gettype($reportConfigurationReportSettingsItem), var_export($reportConfigurationReportSettingsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The reportSettings property can only contain items of type \StructType\ReportSetting, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set reportSettings value
     * @throws \InvalidArgumentException
     * @param \StructType\ReportSetting[] $reportSettings
     * @return \StructType\ReportConfiguration
     */
    public function setReportSettings(array $reportSettings = array())
    {
        // validation for constraint: array
        if ('' !== ($reportSettingsArrayErrorMessage = self::validateReportSettingsForArrayConstraintsFromSetReportSettings($reportSettings))) {
            throw new \InvalidArgumentException($reportSettingsArrayErrorMessage, __LINE__);
        }
        $this->reportSettings = $reportSettings;
        return $this;
    }
    /**
     * Add item to reportSettings value
     * @throws \InvalidArgumentException
     * @param \StructType\ReportSetting $item
     * @return \StructType\ReportConfiguration
     */
    public function addToReportSettings(\StructType\ReportSetting $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReportSetting) {
            throw new \InvalidArgumentException(sprintf('The reportSettings property can only contain items of type \StructType\ReportSetting, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->reportSettings[] = $item;
        return $this;
    }
}
